--    Copyright (C) 2004 by neuron                                          
--    aagaande@gmail.com                                             
--                                                                          
--    This program is free software; you can redistribute it and--or modify  
--    it under the terms of the GNU General Public License as published by  
--    the Free Software Foundation; either version 2 of the License, or     
--    (at your option) any later version.                                   
--                                                                          
--    This program is distributed in the hope that it will be useful,       
--    but WITHOUT ANY WARRANTY; without even the implied warranty of        
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
--    GNU General Public License for more details.                          
--                                                                          
--    You should have received a copy of the GNU General Public License     
--    along with this program; if not, write to the                         
--    Free Software Foundation, Inc.,                                       
--    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

-- Todo, is this better than cartographer : function Tourist:GetYardDistance(zone1, x1, y1, zone2, x2, y2)
-- Todo, make a "show waypoint to questgiver" button?

local L = AceLibrary("AceLocale-2.2"):new("QuestGivers")
L:RegisterTranslations("enUS", function() return {
--	["QuestGivers"] = true,
    ["Description"] = "Tracks quest giver locations",
   	["%s in %s (%d,%d)"] = true,
   	["%s in %s (%d,%d) (%d yd)"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
--	["QuestGivers"] = "퀘스트 제공자",
    ["Description"] = "퀘스트 제공자의 위치를 기록하는 모듈입니다.",
   	["%s in %s (%d,%d)"] = "%s (%s) 좌표: %d, %d",
   	["%s in %s (%d,%d) (%d yd)"] = "%s (%s) 좌표: %d, %d (%d 미터)",
} end)

local moduleName = "QuestGivers"
local QuestGiver = nQuestLog:NewModule(moduleName,"AceEvent-2.0","AceHook-2.1")
local quixote = AceLibrary("Quixote-1.0")

--/script nQuestLog:Print("X : " .. nQuestLog:GetModule("QuestGivers"):Format_QuestGiver("Reclaiming Sunstrider Isle"))

function QuestGiver:OnModuleLoad()
	-- We'd want to set self.name and self.description here? (used for the menu made by parent atleast)
	self.description = L["Description"]
	self.core:RegisterDefaults(moduleName, "char", {
		["questgivers"] = {},
	})
	
	self.core:RegisterDefaults(moduleName, "profile", {
		["enabled"] = true,
	})
end

function QuestGiver:ToggleEnabled(v)
	self.db.profile.enabled = v
	if (v) then
		local function Cleanup()
			for name,_ in pairs(self.db.char.questgivers) do
				if not quixote:GetQuest(name) then
					self.db.char.questgivers[name] = nil
				end
			end
		end

		self:RegisterEvent("Quixote_Ready", Cleanup, true)
		self:Hook("AcceptQuest", true)		
	else
		self:UnregisterEvent("Quixote_Ready", Cleanup, true)
		self:Unhook("AcceptQuest", true)		
	end
end

function QuestGiver:AcceptQuest()
	if UnitName("npc") or UnitIsPlayer("npc") then
		local x,y = GetPlayerMapPosition("player")
		self.db.char.questgivers[GetTitleText()] = {
			npcName = UnitName('npc'),
			location = {
				zone=GetZoneText(), 
				x=x, 
				y=y
			}
		}
	end
	return self.hooks["AcceptQuest"]()
end

--- API:
function QuestGiver:GetQuestGiver(name)
	if (not self.db.char.questgivers[name]) then
		return
	end
	local npcName = self.db.char.questgivers[name].npcName
	local location = self.db.char.questgivers[name].location
	local distance = nil
	if (Cartographer) then
		-- Distance can be nil, depends on Cartographer availability
	
		distance = Cartographer:GetDistanceToPoint(location.x,location.y,location.zone)
		distance = Cartographer:GetDistanceToPoint(location.x,location.y)
	end
	
	return npcName,location,distance
end

-- Function returns localized string of questgiver info, and distance (for hilighting and such)
function QuestGiver:Format_QuestGiver(name,location,distance)
	if (location == nil) then
		name,location,distance = self:GetQuestGiver(name)
	end
	if (name == nil) then
		return
	end
	if (distance) then
		return L["%s in %s (%d,%d) (%d yd)"]:format(name, location.zone, floor(location.x*100), floor(location.y*100), distance),distance
	end
	return L["%s in %s (%d,%d)"]:format(name, location.zone, floor(location.x*100), floor(location.y*100)),distance
end
